#include<stdio.h>
#include "fillp.h"
#include  "3d1.h"
#include  "grf.h"

/*pro proceduru texpolygon, pretejkal zasobnik, 
  protoze pole byla lokalni uvnitr funkce (si myslim)*/
 int Edge1[200][3];    //pro hrany 1-2 a 2-3
 int Edge2[200][3];    //pro hranu 2-3

void gourhline(int x1,int x2, int c1,int c2,
               int y, char *where);


void Gourtriangle(int x1,int y1,int x2,int y2,
                  int x3,int y3, int col1,int col2,
                  int col3,char *where)
{
 int pom,i;                  
 long delt1,delt2,delt3;
 long deltc1,deltc2,deltc3;
 int x1intr,x2intr,c1intr,c2intr;
    
 if (y1>y2) 
  {pom=y1;
   y1=y2;
   y2=pom;
   pom=x1;
   x1=x2;
   x2=pom;
   pom=col1;
   col1=col2;
   col2=pom;
   }
 
 if (y1>y3) 
    {pom=y1;
     y1=y3;
     y3=pom;
     pom=x1;
     x1=x3;
     x3=pom;
     pom=col1;
     col1=col3;
     col3=pom;
     }
 
 if (y2>y3) 
    {pom=y2;
     y2=y3;
     y3=pom;
     pom=x2;
     x2=x3;
     x3=pom;
     pom=col2;
     col2=col3;
     col3=pom;
     }
 
 if (!(y2-y1)) delt1=0,deltc1=0;             //interpolace x a barvy podle y
  else 
   { delt1=((x2-x1)<<16)/(y2-y1);
     deltc1=((col2-col1)<<16)/(y2-y1);
    } 
 
 if (!(y3-y2)) delt2=0,deltc2=0;
  else 
  { delt2=((x3-x2)<<16)/(y3-y2);
    deltc2=((col3-col2)<<16)/(y3-y2);
   }  
 
 if (!(y3-y1)) delt3=0,deltc3=0;  
  else 
   {
    delt3=((x3-x1)<<16)/(y3-y1);
    deltc3=((col3-col1)<<16)/(y3-y1);
    }
 
 x1intr=x2intr=x1<<16;
 c1intr=c2intr=col1<<16;
 for(i=y1;i<(y2+1);i++)
  {
   gourhline(x1intr>>16,x2intr>>16,c1intr>>16,c2intr>>16,i,where);
   x1intr+=delt3;
   x2intr+=delt1;
   c1intr+=deltc3;
   c2intr+=deltc1;
   }
 
 x1intr-=delt3;
 x2intr=x2<<16;
 c1intr-=deltc3;
 c2intr=col2<<16;
 for(i=y2;i<(y3+1);i++)
  {
   gourhline(x1intr>>16,x2intr>>16,c1intr>>16,c2intr>>16,i,where);
   x1intr+=delt3;
   x2intr+=delt2;
   c1intr+=deltc3;
   c2intr+=deltc2;
   }
} 

void gourhline(int x1,int x2, int c1,int c2,
               int y, char *where)
{
 int pom,i;
 long inccolh=0;
 long cintr;
 
  if (x1>x2)
   {
    pom=x1;
    x1=x2;
    x2=pom;
    pom=c1;
    c1=c2;
    c2=pom;
   }

  if (x2-x1) inccolh=((c2-c1)<<8)/(x2-x1);         //interpolacni krok
  if ((x2<min_x) || (x1>max_x)) return;
  if ((y>max_y) || (y<min_y)) return;
  if (x1<min_x)                            //clipping
   { if (x2-x1)
      { c1=((c1<<8)+(min_x-x1)*inccolh)>>8;
       x1=min_x;
      }
   }
  if (x2>max_x)  x2=max_x;
  cintr=c1<<8;
  for(i=x1;i<=x2;i++)
   {vPixScr(i,y,cintr>>8,where);
    cintr+=inccolh;
   }
  //ghline(x1,c1,x2,c2,y,where);
}



void xchange(int *a1,int *a2,int *a3,int *a4,int *a5,int *a6)
{
 int pom;
 pom=*a1;
 *a1=*a2;
 *a2=pom;
 pom=*a3;
 *a3=*a4;
 *a4=pom;
 pom=*a5;
 *a5=*a6;
 *a6=pom;
}

void xchange2(int *a1,int *a2,int *a3,int *a4)
{
 int pom;
 pom=*a1;
 *a1=*a2;
 *a2=pom;
 pom=*a3;
 *a3=*a4;
 *a4=pom;
}

void texpolygon(polygon *txtpoly,char *where)
/* souradnice x,y na obrazovce
   souradnice u,v v texture */  
{
 int x1,y1,x2,y2,x3,y3,u1,v1,u2,v2,u3,v3; 
 int deltx,deltu,deltv;
 int xintr,uintr,vintr;
 int Cnty;

 x1=txtpoly->cornerpoints[1].x;
 y1=txtpoly->cornerpoints[1].y;
 x2=txtpoly->cornerpoints[2].x;
 y2=txtpoly->cornerpoints[2].y;
 x3=txtpoly->cornerpoints[3].x;
 y3=txtpoly->cornerpoints[3].y;
 
 u1=txtpoly->textrpoints[1].x;
 v1=txtpoly->textrpoints[1].y;
 u2=txtpoly->textrpoints[2].x;
 v2=txtpoly->textrpoints[2].y;
 u3=txtpoly->textrpoints[3].x;
 v3=txtpoly->textrpoints[3].y;
 
 if(y1>y2) 
  {
   xchange2(&x1,&x2,&y1,&y2);
   xchange2(&u1,&u2,&v1,&v2);
  }  

 if(y1>y3) 
  {
   xchange2(&x1,&x3,&y1,&y3);
   xchange2(&u1,&u3,&v1,&v3);
  }  

 if(y2>y3) 
  {
   xchange2(&x2,&x3,&y2,&y3);
   xchange2(&u2,&u3,&v2,&v3);
  }  


 if (!(y2-y1)) deltx=0,deltu=0,deltv=0;   // priprava interpl. kroku
   else 
   { deltx=((x2-x1)<<16)/(y2-y1);
     deltu=((u2-u1)<<16)/(y2-y1);
     deltv=((v2-v1)<<16)/(y2-y1);
    } 
 xintr=x1<<16;                     //interpolace x,u,v podle y
 uintr=u1<<16;
 vintr=v1<<16;
 for(Cnty=y1;Cnty<=y2;Cnty++)
  { if ((Cnty>0) && (Cnty<max_y))    //protoze neklipuji, aby nepreteklo pole!!!!
    {
     Edge1[Cnty][0]=xintr>>16;
     Edge1[Cnty][1]=uintr>>16;       // pro hranu 2-1
     Edge1[Cnty][2]=vintr>>16;
    }
    xintr+=deltx;
    uintr+=deltu;
    vintr+=deltv;  
  } 
 
 if (!(y3-y1)) deltx=0,deltu=0,deltv=0;   //priprava interpolacnich kroku
  else 
   { deltx=((x3-x1)<<16)/(y3-y1);
     deltu=((u3-u1)<<16)/(y3-y1);
     deltv=((v3-v1)<<16)/(y3-y1);
    } 
 xintr=x1<<16;                     //interpolace x,u,v podle y
 uintr=u1<<16;
 vintr=v1<<16;
 for(Cnty=y1;Cnty<=y3;Cnty++)
  {if ((Cnty>0) && (Cnty<max_y))
    {
     Edge2[Cnty][0]=xintr>>16;       //  pro hranu 3-1
     Edge2[Cnty][1]=uintr>>16;
     Edge2[Cnty][2]=vintr>>16;
    }
   xintr+=deltx;
   uintr+=deltu;
   vintr+=deltv;
  } 

 if (!(y3-y2)) deltx=0,deltu=0,deltv=0;   //priprava interpolacnich kroku
  else 
   { deltx=((x3-x2)<<16)/(y3-y2);
     deltu=((u3-u2)<<16)/(y3-y2);
     deltv=((v3-v2)<<16)/(y3-y2);
    } 
 xintr=x2<<16;                     //interpolace x,u,v podle y
 uintr=u2<<16;
 vintr=v2<<16;
 for(Cnty=y2;Cnty<=y3;Cnty++)
  {
   if ((Cnty>0) && (Cnty<max_y))
    {
     Edge1[Cnty][0]=xintr>>16;       //  pro hranu 3-2
     Edge1[Cnty][1]=uintr>>16;
     Edge1[Cnty][2]=vintr>>16;
     }
    xintr+=deltx;
    uintr+=deltu;
    vintr+=deltv;
  }

/*cliping souradnice y*/
 if(y1<min_y) y1=min_y;
 if(y1>max_y) return;
 if(y3>max_y) y3=max_y;
 if(y3<min_y) return;


 /*mame pripraveny pole s nainterpolovanejma x u v podle y
   a deme kreslit scanlajny, pri vykreslovani scaline
  interpoluju u,v v texture podle x ve scanline
   bod precteny z textury na u,v zapisu na x,y na obrazovku*/
 /* JE to vlastne procedura texturehline*/
 for(Cnty=y1;Cnty<=y3;Cnty++)
 {int xh1,xh2,uh1,uh2,vh1,vh2; 
  int deltuH,deltvH;
  int Cntx;
  unsigned char color;
    
  xh1=Edge1[Cnty][0];
  xh2=Edge2[Cnty][0];
  uh1=Edge1[Cnty][1];
  uh2=Edge2[Cnty][1];
  vh1=Edge1[Cnty][2];
  vh2=Edge2[Cnty][2];
  if(xh1>xh2) xchange(&xh1,&xh2,&uh1,&uh2,&vh1,&vh2);
  /*spoctu kroky*/
  if (xh2-xh1) 
   { deltuH=((uh2-uh1)<<16)/(xh2-xh1);
     deltvH=((vh2-vh1)<<16)/(xh2-xh1);
   } 
   else deltuH=0,deltuH=0;
  /*ted clipuju  x u a jeste v podle velikosti x*/
  /*DULEZITE MIT PRI NESPLNENI PODMINEK CONTINUE A NE RETURN
    JE TO DANO INTERPOLACI V POLICH!!!!!!!*/

  if(xh1<min_x) 
   if(xh2>min_x)
     {uh1=((uh1<<16)+(min_x-xh1)*deltuH)>>16;
      vh1=((vh1<<16)+(min_x-xh1)*deltvH)>>16;
      xh1=min_x;
     }
     else continue;
  if(xh1>max_x) continue;
  if(xh2<min_x) continue;
  
  if(xh2>max_x)
   if(xh1<max_x)
     {uh2=((uh2<<16)+(max_x-xh2)*deltuH)>>16;
      vh2=((vh2<<16)+(max_x-xh2)*deltvH)>>16; 
      xh2=max_x;
     }
     else continue; 
  /*vykreslovani*/      
  uintr=uh1<<16;
  vintr=vh1<<16;
  for(Cntx=xh1;Cntx<(xh2+1);Cntx++)
   {
    color=txtpoly->textura[(uintr>>16)+128*(vintr>>16)];
    vPixScr(Cntx,Cnty,color,where);
    uintr+=deltuH;
    vintr+=deltvH;
   }
 } //end for cnty    
}  //end proc

